--- /home/monnier/work/xemacs/src/regex.c	Thu Dec 14 17:15:15 2000
+++ src/regex.c.1.138	Thu Apr 26 09:32:57 2001
@@ -3093,7 +3187,7 @@
   free (compile_stack.stack);
 
   /* We have succeeded; set the length of the buffer.  */
-  bufp->used = buf_end - bufp->buffer;
+  bufp->used = b - bufp->buffer;
 
 #ifdef DEBUG
   if (debug)
@@ -3110,12 +3204,9 @@
   {
     int num_regs = bufp->re_nsub + 1;
 
-    /* Since DOUBLE_FAIL_STACK refuses to double only if the current size
-       is strictly greater than re_max_failures, the largest possible stack
-       is 2 * re_max_failures failure points.  */
-    if (fail_stack.size < (2 * re_max_failures * MAX_FAILURE_ITEMS))
+    if (fail_stack.size < re_max_failures * TYPICAL_FAILURE_SIZE)
       {
-	fail_stack.size = (2 * re_max_failures * MAX_FAILURE_ITEMS);
+	fail_stack.size = re_max_failures * TYPICAL_FAILURE_SIZE;
 
 #ifdef emacs
 	if (! fail_stack.stack)
@@ -3137,7 +3228,7 @@
 	    = (fail_stack_elt_t *) realloc (fail_stack.stack,
 					    (fail_stack.size
 					     * sizeof (fail_stack_elt_t)));
-#endif /* emacs */
+#endif /* not emacs */
       }
 
     regex_grow_registers (num_regs);
@@ -3149,10 +3240,13 @@
 
 /* Subroutines for `regex_compile'.  */
 
-/* Store OP at LOC followed by two-byte integer parameter ARG.  */
+/* Store OP at LOC followed by two-byte integer parameter ARG.	*/
 
 static void
-store_op1 (re_opcode_t op, unsigned char *loc, int arg)
+store_op1 (op, loc, arg)
+    re_opcode_t op;
+    unsigned char *loc;
+    int arg;
 {
   *loc = (unsigned char) op;
   STORE_NUMBER (loc + 1, arg);
@@ -3162,7 +3256,10 @@
 /* Like `store_op1', but for two two-byte parameters ARG1 and ARG2.  */
 
 static void
-store_op2 (re_opcode_t op, unsigned char *loc, int arg1, int arg2)
+store_op2 (op, loc, arg1, arg2)
+    re_opcode_t op;
+    unsigned char *loc;
+    int arg1, arg2;
 {
   *loc = (unsigned char) op;
   STORE_NUMBER (loc + 1, arg1);
@@ -3174,10 +3271,14 @@
    for OP followed by two-byte integer parameter ARG.  */
 
 static void
-insert_op1 (re_opcode_t op, unsigned char *loc, int arg, unsigned char *end)
+insert_op1 (op, loc, arg, end)
+    re_opcode_t op;
+    unsigned char *loc;
+    int arg;
+    unsigned char *end;
 {
-  REGISTER unsigned char *pfrom = end;
-  REGISTER unsigned char *pto = end + 3;
+  register unsigned char *pfrom = end;
+  register unsigned char *pto = end + 3;
 
   while (pfrom != loc)
     *--pto = *--pfrom;
@@ -3189,11 +3290,14 @@
 /* Like `insert_op1', but for two two-byte parameters ARG1 and ARG2.  */
 
 static void
-insert_op2 (re_opcode_t op, unsigned char *loc, int arg1, int arg2,
-	    unsigned char *end)
+insert_op2 (op, loc, arg1, arg2, end)
+    re_opcode_t op;
+    unsigned char *loc;
+    int arg1, arg2;
+    unsigned char *end;
 {
-  REGISTER unsigned char *pfrom = end;
-  REGISTER unsigned char *pto = end + 5;
+  register unsigned char *pfrom = end;
+  register unsigned char *pto = end + 5;
 
   while (pfrom != loc)
     *--pto = *--pfrom;
@@ -3207,15 +3311,17 @@
    least one character before the ^.  */
 
 static boolean
-at_begline_loc_p (re_char *pattern, re_char *p, reg_syntax_t syntax)
+at_begline_loc_p (pattern, p, syntax)
+    const char *pattern, *p;
+    reg_syntax_t syntax;
 {
-  re_char *prev = p - 2;
+  const char *prev = p - 2;
   boolean prev_prev_backslash = prev > pattern && prev[-1] == '\\';
 
   return
        /* After a subexpression?  */
        (*prev == '(' && (syntax & RE_NO_BK_PARENS || prev_prev_backslash))
-       /* After an alternative?  */
+       /* After an alternative?	 */
     || (*prev == '|' && (syntax & RE_NO_BK_VBAR || prev_prev_backslash));
 }
 
@@ -3224,19 +3330,21 @@
    at least one character after the $, i.e., `P < PEND'.  */
 
 static boolean
-at_endline_loc_p (re_char *p, re_char *pend, int syntax)
+at_endline_loc_p (p, pend, syntax)
+    const char *p, *pend;
+    int syntax;
 {
-  re_char *next = p;
+  const char *next = p;
   boolean next_backslash = *next == '\\';
-  re_char *next_next = p + 1 < pend ? p + 1 : 0;
+  const char *next_next = p + 1 < pend ? p + 1 : 0;
 
   return
        /* Before a subexpression?  */
        (syntax & RE_NO_BK_PARENS ? *next == ')'
-        : next_backslash && next_next && *next_next == ')')
+	: next_backslash && next_next && *next_next == ')')
        /* Before an alternative?  */
     || (syntax & RE_NO_BK_VBAR ? *next == '|'
-        : next_backslash && next_next && *next_next == '|');
+	: next_backslash && next_next && *next_next == '|');
 }
 
 
@@ -3244,7 +3352,9 @@
    false if it's not.  */
 
 static boolean
-group_in_compile_stack (compile_stack_type compile_stack, regnum_t regnum)
+group_in_compile_stack (compile_stack, regnum)
+    compile_stack_type compile_stack;
+    regnum_t regnum;
 {
   int this_element;
 
@@ -3256,130 +3366,16 @@
 
   return false;
 }
-
-
-/* Read the ending character of a range (in a bracket expression) from the
-   uncompiled pattern *P_PTR (which ends at PEND).  We assume the
-   starting character is in `P[-2]'.  (`P[-1]' is the character `-'.)
-   Then we set the translation of all bits between the starting and
-   ending characters (inclusive) in the compiled pattern B.
-
-   Return an error code.
-
-   We use these short variable names so we can use the same macros as
-   `regex_compile' itself.  */
-
-static reg_errcode_t
-compile_range (re_char **p_ptr, re_char *pend, RE_TRANSLATE_TYPE translate,
-	       reg_syntax_t syntax, unsigned char *buf_end)
-{
-  unsigned this_char;
-
-  re_char *p = *p_ptr;
-  int range_start, range_end;
-
-  if (p == pend)
-    return REG_ERANGE;
-
-  /* Even though the pattern is a signed `char *', we need to fetch
-     with unsigned char *'s; if the high bit of the pattern character
-     is set, the range endpoints will be negative if we fetch using a
-     signed char *.
-
-     We also want to fetch the endpoints without translating them; the
-     appropriate translation is done in the bit-setting loop below.  */
-  /* The SVR4 compiler on the 3B2 had trouble with unsigned const char *.  */
-  range_start = ((const unsigned char *) p)[-2];
-  range_end   = ((const unsigned char *) p)[0];
-
-  /* Have to increment the pointer into the pattern string, so the
-     caller isn't still at the ending character.  */
-  (*p_ptr)++;
-
-  /* If the start is after the end, the range is empty.  */
-  if (range_start > range_end)
-    return syntax & RE_NO_EMPTY_RANGES ? REG_ERANGE : REG_NOERROR;
-
-  /* Here we see why `this_char' has to be larger than an `unsigned
-     char' -- the range is inclusive, so if `range_end' == 0xff
-     (assuming 8-bit characters), we would otherwise go into an infinite
-     loop, since all characters <= 0xff.  */
-  for (this_char = range_start; this_char <= range_end; this_char++)
-    {
-      SET_LIST_BIT (TRANSLATE (this_char));
-    }
-
-  return REG_NOERROR;
-}
-
-#ifdef MULE
-
-static reg_errcode_t
-compile_extended_range (re_char **p_ptr, re_char *pend,
-			RE_TRANSLATE_TYPE translate,
-			reg_syntax_t syntax, Lisp_Object rtab)
-{
-  Emchar this_char, range_start, range_end;
-  const Bufbyte *p;
-
-  if (*p_ptr == pend)
-    return REG_ERANGE;
-
-  p = (const Bufbyte *) *p_ptr;
-  range_end = charptr_emchar (p);
-  p--; /* back to '-' */
-  DEC_CHARPTR (p); /* back to start of range */
-  /* We also want to fetch the endpoints without translating them; the
-     appropriate translation is done in the bit-setting loop below.  */
-  range_start = charptr_emchar (p);
-  INC_CHARPTR (*p_ptr);
-
-  /* If the start is after the end, the range is empty.  */
-  if (range_start > range_end)
-    return syntax & RE_NO_EMPTY_RANGES ? REG_ERANGE : REG_NOERROR;
-
-  /* Can't have ranges spanning different charsets, except maybe for
-     ranges entirely within the first 256 chars. */
-
-  if ((range_start >= 0x100 || range_end >= 0x100)
-      && CHAR_LEADING_BYTE (range_start) !=
-      CHAR_LEADING_BYTE (range_end))
-    return REG_ERANGESPAN;
-
-  /* As advertised, translations only work over the 0 - 0x7F range.
-     Making this kind of stuff work generally is much harder.
-     Iterating over the whole range like this would be way efficient
-     if the range encompasses 10,000 chars or something.  You'd have
-     to do something like this:
-
-     range_table a;
-     range_table b;
-     map over translation table in [range_start, range_end] of
-       (put the mapped range in a;
-        put the translation in b)
-     invert the range in a and truncate to [range_start, range_end]
-     compute the union of a, b
-     union the result into rtab
-   */
-  for (this_char = range_start;
-       this_char <= range_end && this_char < 0x80; this_char++)
-    {
-      SET_RANGETAB_BIT (TRANSLATE (this_char));
-    }
-
-  if (this_char <= range_end)
-    put_range_table (rtab, this_char, range_end, Qt);
-
-  return REG_NOERROR;
-}
-
-#endif /* MULE */
 
 /* re_compile_fastmap computes a ``fastmap'' for the compiled pattern in
    BUFP.  A fastmap records which of the (1 << BYTEWIDTH) possible
    characters can start a string that matches the pattern.  This fastmap
    is used by re_search to skip quickly over impossible starting points.
 
+   Character codes above (1 << BYTEWIDTH) are not represented in the
+   fastmap, but the leading codes are represented.  Thus, the fastmap
+   indicates which character sets could start a match.
+
    The caller must supply the address of a (1 << BYTEWIDTH)-byte data
    area as BUFP->fastmap.
 
@@ -3389,29 +3385,31 @@
    Returns 0 if we succeed, -2 if an internal error.   */
 
 int
-re_compile_fastmap (struct re_pattern_buffer *bufp)
+re_compile_fastmap (bufp)
+     struct re_pattern_buffer *bufp;
 {
-  int j, k;
+  int i, j, k;
 #ifdef MATCH_MAY_ALLOCATE
   fail_stack_type fail_stack;
 #endif
-  DECLARE_DESTINATION
+#ifndef REGEX_MALLOC
+  char *destination;
+#endif
   /* We don't push any register information onto the failure stack.  */
+  unsigned num_regs = 0;
 
-  REGISTER char *fastmap = bufp->fastmap;
+  register char *fastmap = bufp->fastmap;
   unsigned char *pattern = bufp->buffer;
   unsigned long size = bufp->used;
   unsigned char *p = pattern;
-  REGISTER unsigned char *pend = pattern + size;
+  register unsigned char *pend = pattern + size;
 
-#ifdef REL_ALLOC
   /* This holds the pointer to the failure stack, when
      it is allocated relocatably.  */
   fail_stack_elt_t *failure_stack_ptr;
-#endif
 
   /* Assume that each path through the pattern can be null until
-     proven otherwise.  We set this false at the bottom of switch
+     proven otherwise.	We set this false at the bottom of switch
      statement, to which we get only if a particular path doesn't
      match the empty string.  */
   boolean path_can_be_null = true;
@@ -3419,10 +3417,17 @@
   /* We aren't doing a `succeed_n' to begin with.  */
   boolean succeed_n_p = false;
 
+  /* If all elements for base leading-codes in fastmap is set, this
+     flag is set true.	*/
+  boolean match_any_multibyte_characters = false;
+
+  /* Maximum code of simple (single byte) character. */
+  int simple_char_max;
+
   assert (fastmap != NULL && p != NULL);
 
   INIT_FAIL_STACK ();
-  memset (fastmap, 0, 1 << BYTEWIDTH);  /* Assume nothing's valid.  */
+  bzero (fastmap, 1 << BYTEWIDTH);  /* Assume nothing's valid.	*/
   bufp->fastmap_accurate = 1;	    /* It will be when we're done.  */
   bufp->can_be_null = 0;
 
@@ -3438,7 +3443,7 @@
 	      /* Reset for next path.  */
 	      path_can_be_null = true;
 
-	      p = (unsigned char *) fail_stack.stack[--fail_stack.avail].pointer;
+	      p = fail_stack.stack[--fail_stack.avail].pointer;
 
 	      continue;
 	    }
@@ -3446,169 +3451,187 @@
 	    break;
 	}
 
-      /* We should never be about to go beyond the end of the pattern.  */
+      /* We should never be about to go beyond the end of the pattern.	*/
       assert (p < pend);
 
       switch (SWITCH_ENUM_CAST ((re_opcode_t) *p++))
 	{
 
-        /* I guess the idea here is to simply not bother with a fastmap
-           if a backreference is used, since it's too hard to figure out
-           the fastmap for the corresponding group.  Setting
-           `can_be_null' stops `re_search_2' from using the fastmap, so
-           that is all we do.  */
+	/* I guess the idea here is to simply not bother with a fastmap
+	   if a backreference is used, since it's too hard to figure out
+	   the fastmap for the corresponding group.  Setting
+	   `can_be_null' stops `re_search_2' from using the fastmap, so
+	   that is all we do.  */
 	case duplicate:
 	  bufp->can_be_null = 1;
-          goto done;
+	  goto done;
 
 
       /* Following are the cases which match a character.  These end
-         with `break'.  */
+	 with `break'.	*/
 
 	case exactn:
-          fastmap[p[1]] = 1;
+	  fastmap[p[1]] = 1;
 	  break;
 
 
-        case charset:
-	  /* XEmacs: Under Mule, these bit vectors will
-	     only contain values for characters below 0x80. */
-          for (j = *p++ * BYTEWIDTH - 1; j >= 0; j--)
-	    if (p[j / BYTEWIDTH] & (1 << (j % BYTEWIDTH)))
-              fastmap[j] = 1;
-	  break;
+#ifndef emacs
+	case charset:
+	  {
+	    int length = (*p & 0x7f);;
+	    p++;
 
+	    for (j = length * BYTEWIDTH - 1; j >= 0; j--)
+	      if (p[j / BYTEWIDTH] & (1 << (j % BYTEWIDTH)))
+		fastmap[j] = 1;
+	  }
+	  break;
 
 	case charset_not:
 	  /* Chars beyond end of map must be allowed.  */
-#ifdef MULE
-	  for (j = *p * BYTEWIDTH; j < 0x80; j++)
-            fastmap[j] = 1;
-	  /* And all extended characters must be allowed, too. */
-	  for (j = 0x80; j < 0xA0; j++)
-	    fastmap[j] = 1;
-#else /* not MULE */
-	  for (j = *p * BYTEWIDTH; j < (1 << BYTEWIDTH); j++)
-            fastmap[j] = 1;
-#endif /* MULE */
-
-	  for (j = *p++ * BYTEWIDTH - 1; j >= 0; j--)
-	    if (!(p[j / BYTEWIDTH] & (1 << (j % BYTEWIDTH))))
-              fastmap[j] = 1;
-          break;
-
-#ifdef MULE
-	case charset_mule:
 	  {
-	    int nentries;
-	    int i;
+	    int length = (*p & 0x7f);;
+	    p++;
 
-	    nentries = unified_range_table_nentries (p);
-	    for (i = 0; i < nentries; i++)
-	      {
-		EMACS_INT first, last;
-		Lisp_Object dummy_val;
-		int jj;
-		Bufbyte strr[MAX_EMCHAR_LEN];
-
-		unified_range_table_get_range (p, i, &first, &last,
-					       &dummy_val);
-		for (jj = first; jj <= last && jj < 0x80; jj++)
-		  fastmap[jj] = 1;
-		/* Ranges below 0x100 can span charsets, but there
-		   are only two (Control-1 and Latin-1), and
-		   either first or last has to be in them. */
-		set_charptr_emchar (strr, first);
-		fastmap[*strr] = 1;
-		if (last < 0x100)
-		  {
-		    set_charptr_emchar (strr, last);
-		    fastmap[*strr] = 1;
-		  }
-	      }
+	    for (j = length * BYTEWIDTH; j < (1 << BYTEWIDTH); j++)
+	      fastmap[j] = 1;
+
+	    for (j = length * BYTEWIDTH - 1; j >= 0; j--)
+	      if (!(p[j / BYTEWIDTH] & (1 << (j % BYTEWIDTH))))
+		fastmap[j] = 1;
 	  }
 	  break;
 
-	case charset_mule_not:
-	  {
-	    int nentries;
-	    int i;
+	case wordchar:
+	  for (j = 0; j < (1 << BYTEWIDTH); j++)
+	    if (SYNTAX (j) == Sword)
+	      fastmap[j] = 1;
+	  break;
 
-	    nentries = unified_range_table_nentries (p);
-	    for (i = 0; i < nentries; i++)
-	      {
-		EMACS_INT first, last;
-		Lisp_Object dummy_val;
-		int jj;
-		int smallest_prev = 0;
-
-		unified_range_table_get_range (p, i, &first, &last,
-					       &dummy_val);
-		for (jj = smallest_prev; jj < first && jj < 0x80; jj++)
-		  fastmap[jj] = 1;
-		smallest_prev = last + 1;
-		if (smallest_prev >= 0x80)
-		  break;
-	      }
-	    /* Calculating which leading bytes are actually allowed
-	       here is rather difficult, so we just punt and allow
-	       all of them. */
-	    for (i = 0x80; i < 0xA0; i++)
-	      fastmap[i] = 1;
-	  }
+
+	case notwordchar:
+	  for (j = 0; j < (1 << BYTEWIDTH); j++)
+	    if (SYNTAX (j) != Sword)
+	      fastmap[j] = 1;
+	  break;
+#else  /* emacs */
+	case charset:
+	  for (j = CHARSET_BITMAP_SIZE (&p[-1]) * BYTEWIDTH - 1, p++;
+	       j >= 0; j--)
+	    if (p[j / BYTEWIDTH] & (1 << (j % BYTEWIDTH)))
+	      fastmap[j] = 1;
+
+	  /* If we can match a character class, we can match
+	     any character set.  */
+	  if (CHARSET_RANGE_TABLE_EXISTS_P (&p[-2])
+	      && CHARSET_RANGE_TABLE_BITS (&p[-2]) != 0)
+	    goto set_fastmap_for_multibyte_characters;
+
+	  if (CHARSET_RANGE_TABLE_EXISTS_P (&p[-2])
+	      && match_any_multibyte_characters == false)
+	    {
+	      /* Set fastmap[I] 1 where I is a base leading code of each
+		 multibyte character in the range table. */
+	      int c, count;
+
+	      /* Make P points the range table.  `+ 2' is to skip flag
+                 bits for a character class.  */
+	      p += CHARSET_BITMAP_SIZE (&p[-2]) + 2;
+
+	      /* Extract the number of ranges in range table into COUNT.  */
+	      EXTRACT_NUMBER_AND_INCR (count, p);
+	      for (; count > 0; count--, p += 2 * 3) /* XXX */
+		{
+		  /* Extract the start of each range.  */
+		  EXTRACT_CHARACTER (c, p);
+		  j = CHAR_CHARSET (c);
+		  fastmap[CHARSET_LEADING_CODE_BASE (j)] = 1;
+		}
+	    }
+	  break;
+
+
+	case charset_not:
+	  /* Chars beyond end of bitmap are possible matches.
+	     All the single-byte codes can occur in multibyte buffers.
+	     So any that are not listed in the charset
+	     are possible matches, even in multibyte buffers.  */
+	  simple_char_max = (1 << BYTEWIDTH);
+	  for (j = CHARSET_BITMAP_SIZE (&p[-1]) * BYTEWIDTH;
+	       j < simple_char_max; j++)
+	    fastmap[j] = 1;
+
+	  for (j = CHARSET_BITMAP_SIZE (&p[-1]) * BYTEWIDTH - 1, p++;
+	       j >= 0; j--)
+	    if (!(p[j / BYTEWIDTH] & (1 << (j % BYTEWIDTH))))
+	      fastmap[j] = 1;
+
+	  if (bufp->multibyte)
+	    /* Any character set can possibly contain a character
+	       which doesn't match the specified set of characters.  */
+	    {
+	    set_fastmap_for_multibyte_characters:
+	      if (match_any_multibyte_characters == false)
+		{
+		  for (j = 0x80; j < 0xA0; j++)	/* XXX */
+		    if (BASE_LEADING_CODE_P (j))
+		      fastmap[j] = 1;
+		  match_any_multibyte_characters = true;
+		}
+	    }
 	  break;
-#endif /* MULE */
 
 
 	case wordchar:
-#ifdef emacs
-	  k = (int) Sword;
-	  goto matchsyntax;
-#else
-	  for (j = 0; j < (1 << BYTEWIDTH); j++)
-	    if (SYNTAX_UNSAFE
-		(XCHAR_TABLE
-		 (regex_emacs_buffer->mirror_syntax_table), j) == Sword)
+	  /* All the single-byte codes can occur in multibyte buffers,
+	     and they may have word syntax.  So do consider them.  */
+	  simple_char_max = (1 << BYTEWIDTH);
+	  for (j = 0; j < simple_char_max; j++)
+	    if (SYNTAX (j) == Sword)
 	      fastmap[j] = 1;
+
+	  if (bufp->multibyte)
+	    /* Any character set can possibly contain a character
+	       whose syntax is `Sword'.	 */
+	    goto set_fastmap_for_multibyte_characters;
 	  break;
-#endif
 
 
 	case notwordchar:
-#ifdef emacs
-	  k = (int) Sword;
-	  goto matchnotsyntax;
-#else
-	  for (j = 0; j < (1 << BYTEWIDTH); j++)
-	    if (SYNTAX_UNSAFE
-		(XCHAR_TABLE
-		 (regex_emacs_buffer->mirror_syntax_table), j) != Sword)
+	  /* All the single-byte codes can occur in multibyte buffers,
+	     and they may not have word syntax.  So do consider them.  */
+	  simple_char_max = (1 << BYTEWIDTH);
+	  for (j = 0; j < simple_char_max; j++)
+	    if (SYNTAX (j) != Sword)
 	      fastmap[j] = 1;
+
+	  if (bufp->multibyte)
+	    /* Any character set can possibly contain a character
+	       whose syntax is not `Sword'.  */
+	    goto set_fastmap_for_multibyte_characters;
 	  break;
 #endif
 
-
-        case anychar:
+	case anychar:
 	  {
 	    int fastmap_newline = fastmap['\n'];
 
-	    /* `.' matches anything ...  */
-#ifdef MULE
-	    /* "anything" only includes bytes that can be the
-	       first byte of a character. */
-	    for (j = 0; j < 0xA0; j++)
+	    /* `.' matches anything, except perhaps newline.
+	       Even in a multibyte buffer, it should match any
+	       conceivable byte value for the fastmap.  */
+	    if (bufp->multibyte)
+	      match_any_multibyte_characters = true;
+
+	    simple_char_max = (1 << BYTEWIDTH);
+	    for (j = 0; j < simple_char_max; j++)
 	      fastmap[j] = 1;
-#else
-	    for (j = 0; j < (1 << BYTEWIDTH); j++)
-	      fastmap[j] = 1;
-#endif
 
 	    /* ... except perhaps newline.  */
 	    if (!(bufp->syntax & RE_DOT_NEWLINE))
 	      fastmap['\n'] = fastmap_newline;
 
 	    /* Return if we have already set `can_be_null'; if we have,
-	       then the fastmap is irrelevant.  Something's wrong here.  */
+	       then the fastmap is irrelevant.	Something's wrong here.	 */
 	    else if (bufp->can_be_null)
 	      goto done;
 
@@ -3617,226 +3640,203 @@
 	  }
 
 #ifdef emacs
-        case syntaxspec:
+	case wordbound:
+	case notwordbound:
+	case wordbeg:
+	case wordend:
+	case notsyntaxspec:
+	case syntaxspec:
+	  /* This match depends on text properties.  These end with
+	     aborting optimizations.  */
+	  bufp->can_be_null = 1;
+	  goto done;
+#if 0
 	  k = *p++;
-	  matchsyntax:
-#ifdef MULE
-	  for (j = 0; j < 0x80; j++)
-	    if (SYNTAX_UNSAFE
-		(XCHAR_TABLE
-		 (regex_emacs_buffer->mirror_syntax_table), j) ==
-		(enum syntaxcode) k)
+	  simple_char_max = bufp->multibyte ? 0x80 : (1 << BYTEWIDTH);
+	  for (j = 0; j < simple_char_max; j++)
+	    if (SYNTAX (j) == (enum syntaxcode) k)
 	      fastmap[j] = 1;
-	  for (j = 0x80; j < 0xA0; j++)
-	    {
-	      if (LEADING_BYTE_PREFIX_P(j))
-		/* too complicated to calculate this right */
-		fastmap[j] = 1;
-	      else
-		{
-		  int multi_p;
-		  Lisp_Object cset;
 
-		  cset = CHARSET_BY_LEADING_BYTE (j);
-		  if (CHARSETP (cset))
-		    {
-		      if (charset_syntax (regex_emacs_buffer, cset,
-					  &multi_p)
-			  == Sword || multi_p)
-			fastmap[j] = 1;
-		    }
-		}
-	    }
-#else /* not MULE */
-	  for (j = 0; j < (1 << BYTEWIDTH); j++)
-	    if (SYNTAX_UNSAFE
-		(XCHAR_TABLE
-		 (regex_emacs_buffer->mirror_syntax_table), j) ==
-		(enum syntaxcode) k)
-	      fastmap[j] = 1;
-#endif /* MULE */
+	  if (bufp->multibyte)
+	    /* Any character set can possibly contain a character
+	       whose syntax is K.  */
+	    goto set_fastmap_for_multibyte_characters;
 	  break;
 
-
 	case notsyntaxspec:
 	  k = *p++;
-	  matchnotsyntax:
-#ifdef MULE
-	  for (j = 0; j < 0x80; j++)
-	    if (SYNTAX_UNSAFE
-		(XCHAR_TABLE
-		 (regex_emacs_buffer->mirror_syntax_table), j) !=
-		(enum syntaxcode) k)
+	  simple_char_max = bufp->multibyte ? 0x80 : (1 << BYTEWIDTH);
+	  for (j = 0; j < simple_char_max; j++)
+	    if (SYNTAX (j) != (enum syntaxcode) k)
 	      fastmap[j] = 1;
-	  for (j = 0x80; j < 0xA0; j++)
-	    {
-	      if (LEADING_BYTE_PREFIX_P(j))
-		/* too complicated to calculate this right */
-		fastmap[j] = 1;
-	      else
-		{
-		  int multi_p;
-		  Lisp_Object cset;
 
-		  cset = CHARSET_BY_LEADING_BYTE (j);
-		  if (CHARSETP (cset))
-		    {
-		      if (charset_syntax (regex_emacs_buffer, cset,
-					  &multi_p)
-			  != Sword || multi_p)
-			fastmap[j] = 1;
-		    }
-		}
-	    }
-#else /* not MULE */
-	  for (j = 0; j < (1 << BYTEWIDTH); j++)
-	    if (SYNTAX_UNSAFE
-		(XCHAR_TABLE
-		 (regex_emacs_buffer->mirror_syntax_table), j) !=
-		(enum syntaxcode) k)
-	      fastmap[j] = 1;
-#endif /* MULE */
+	  if (bufp->multibyte)
+	    /* Any character set can possibly contain a character
+	       whose syntax is not K.  */
+	    goto set_fastmap_for_multibyte_characters;
 	  break;
+#endif
+
 
-#ifdef MULE
-/* 97/2/17 jhod category patch */
 	case categoryspec:
+	  k = *p++;
+	  simple_char_max = (1 << BYTEWIDTH);
+	  for (j = 0; j < simple_char_max; j++)
+	    if (CHAR_HAS_CATEGORY (j, k))
+	      fastmap[j] = 1;
+
+	  if (bufp->multibyte)
+	    /* Any character set can possibly contain a character
+	       whose category is K.  */
+	    goto set_fastmap_for_multibyte_characters;
+	  break;
+
+
 	case notcategoryspec:
-	  bufp->can_be_null = 1;
-	  return 0;
-/* end if category patch */
-#endif /* MULE */
+	  k = *p++;
+	  simple_char_max = (1 << BYTEWIDTH);
+	  for (j = 0; j < simple_char_max; j++)
+	    if (!CHAR_HAS_CATEGORY (j, k))
+	      fastmap[j] = 1;
+
+	  if (bufp->multibyte)
+	    /* Any character set can possibly contain a character
+	       whose category is not K.	 */
+	    goto set_fastmap_for_multibyte_characters;
+	  break;
 
       /* All cases after this match the empty string.  These end with
-         `continue'.  */
+	 `continue'.  */
 
 
 	case before_dot:
 	case at_dot:
 	case after_dot:
-          continue;
-#endif /* not emacs */
+	  continue;
+#endif /* emacs */
 
 
-        case no_op:
-        case begline:
-        case endline:
+	case no_op:
+	case begline:
+	case endline:
 	case begbuf:
 	case endbuf:
+#ifndef emacs
 	case wordbound:
 	case notwordbound:
 	case wordbeg:
 	case wordend:
-        case push_dummy_failure:
-          continue;
+#endif
+	case push_dummy_failure:
+	  continue;
 
 
 	case jump_n:
-        case pop_failure_jump:
+	case pop_failure_jump:
 	case maybe_pop_jump:
 	case jump:
-        case jump_past_alt:
+	case jump_past_alt:
 	case dummy_failure_jump:
-          EXTRACT_NUMBER_AND_INCR (j, p);
+	  EXTRACT_NUMBER_AND_INCR (j, p);
 	  p += j;
 	  if (j > 0)
 	    continue;
 
-          /* Jump backward implies we just went through the body of a
-             loop and matched nothing.  Opcode jumped to should be
-             `on_failure_jump' or `succeed_n'.  Just treat it like an
-             ordinary jump.  For a * loop, it has pushed its failure
-             point already; if so, discard that as redundant.  */
-          if ((re_opcode_t) *p != on_failure_jump
+	  /* Jump backward implies we just went through the body of a
+	     loop and matched nothing.	Opcode jumped to should be
+	     `on_failure_jump' or `succeed_n'.	Just treat it like an
+	     ordinary jump.  For a * loop, it has pushed its failure
+	     point already; if so, discard that as redundant.  */
+	  if ((re_opcode_t) *p != on_failure_jump
 	      && (re_opcode_t) *p != succeed_n)
 	    continue;
 
-          p++;
-          EXTRACT_NUMBER_AND_INCR (j, p);
-          p += j;
+	  p++;
+	  EXTRACT_NUMBER_AND_INCR (j, p);
+	  p += j;
 
-          /* If what's on the stack is where we are now, pop it.  */
-          if (!FAIL_STACK_EMPTY ()
+	  /* If what's on the stack is where we are now, pop it.  */
+	  if (!FAIL_STACK_EMPTY ()
 	      && fail_stack.stack[fail_stack.avail - 1].pointer == p)
-            fail_stack.avail--;
+	    fail_stack.avail--;
 
-          continue;
+	  continue;
 
 
-        case on_failure_jump:
-        case on_failure_keep_string_jump:
+	case on_failure_jump:
+	case on_failure_keep_string_jump:
 	handle_on_failure_jump:
-          EXTRACT_NUMBER_AND_INCR (j, p);
+	  EXTRACT_NUMBER_AND_INCR (j, p);
 
-          /* For some patterns, e.g., `(a?)?', `p+j' here points to the
-             end of the pattern.  We don't want to push such a point,
-             since when we restore it above, entering the switch will
-             increment `p' past the end of the pattern.  We don't need
-             to push such a point since we obviously won't find any more
-             fastmap entries beyond `pend'.  Such a pattern can match
-             the null string, though.  */
-          if (p + j < pend)
-            {
-              if (!PUSH_PATTERN_OP (p + j, fail_stack))
+	  /* For some patterns, e.g., `(a?)?', `p+j' here points to the
+	     end of the pattern.  We don't want to push such a point,
+	     since when we restore it above, entering the switch will
+	     increment `p' past the end of the pattern.	 We don't need
+	     to push such a point since we obviously won't find any more
+	     fastmap entries beyond `pend'.  Such a pattern can match
+	     the null string, though.  */
+	  if (p + j < pend)
+	    {
+	      if (!PUSH_PATTERN_OP (p + j, fail_stack))
 		{
 		  RESET_FAIL_STACK ();
 		  return -2;
 		}
-            }
-          else
-            bufp->can_be_null = 1;
+	    }
+	  else
+	    bufp->can_be_null = 1;
 
-          if (succeed_n_p)
-            {
-              EXTRACT_NUMBER_AND_INCR (k, p);	/* Skip the n.  */
-              succeed_n_p = false;
+	  if (succeed_n_p)
+	    {
+	      EXTRACT_NUMBER_AND_INCR (k, p);	/* Skip the n.	*/
+	      succeed_n_p = false;
 	    }
 
-          continue;
+	  continue;
 
 
 	case succeed_n:
-          /* Get to the number of times to succeed.  */
-          p += 2;
+	  /* Get to the number of times to succeed.  */
+	  p += 2;
 
-          /* Increment p past the n for when k != 0.  */
-          EXTRACT_NUMBER_AND_INCR (k, p);
-          if (k == 0)
+	  /* Increment p past the n for when k != 0.  */
+	  EXTRACT_NUMBER_AND_INCR (k, p);
+	  if (k == 0)
 	    {
-              p -= 4;
-  	      succeed_n_p = true;  /* Spaghetti code alert.  */
-              goto handle_on_failure_jump;
-            }
-          continue;
+	      p -= 4;
+	      succeed_n_p = true;  /* Spaghetti code alert.  */
+	      goto handle_on_failure_jump;
+	    }
+	  continue;
 
 
 	case set_number_at:
-          p += 4;
-          continue;
+	  p += 4;
+	  continue;
 
 
 	case start_memory:
-        case stop_memory:
+	case stop_memory:
 	  p += 2;
 	  continue;
 
 
 	default:
-          abort (); /* We have listed all the cases.  */
-        } /* switch *p++ */
+	  abort (); /* We have listed all the cases.  */
+	} /* switch *p++ */
 
       /* Getting here means we have found the possible starting
-         characters for one path of the pattern -- and that the empty
-         string does not match.  We need not follow this path further.
-         Instead, look at the next alternative (remembered on the
-         stack), or quit if no more.  The test at the top of the loop
-         does these things.  */
+	 characters for one path of the pattern -- and that the empty
+	 string does not match.	 We need not follow this path further.
+	 Instead, look at the next alternative (remembered on the
+	 stack), or quit if no more.  The test at the top of the loop
+	 does these things.  */
       path_can_be_null = false;
       p = pend;
     } /* while p */
 
   /* Set `can_be_null' for the last path (also the first path, if the
-     pattern is empty).  */
+     pattern is empty).	 */
   bufp->can_be_null |= path_can_be_null;
 
  done:
@@ -3858,8 +3858,11 @@
    freeing the old data.  */
 
 void
-re_set_registers (struct re_pattern_buffer *bufp, struct re_registers *regs,
-		  unsigned num_regs, regoff_t *starts, regoff_t *ends)
+re_set_registers (bufp, regs, num_regs, starts, ends)
+    struct re_pattern_buffer *bufp;
+    struct re_registers *regs;
+    unsigned num_regs;
+    regoff_t *starts, *ends;
 {
   if (num_regs)
     {
